<template lang="pug">
AnimGroup(animIn="flipIn" animOut="flipOut" tag="tr")
  td.p-1(ref="name" key="title" animIn="fadeIn" animOut="fadeOut")
    a(:href='project.web_url') {{ name }}

  td.p-1.text-center(ref="badges" v-for="badge in badges" :key="badge.id")
    Img(:src="badge.rendered_image_url" :href="badge.rendered_link_url")
  td.p-1(v-if="!badges" key="loader" animIn="fadeIn" animOut="")
    .abs-top-center.text-center
      .fa.fa-spinner.fa-pulse
</template>

<script>
import axios from 'axios'

import Img from './BaseImage.vue'
import AnimGroup from './BaseAnimationGroup.vue'
import AnimBlock from './BaseAnimationBlock.vue'
import AnimLoader from './BaseAnimationLoader.vue'

import { currentUrl, fetchAllPages } from './utilities'

export default {
  props: {
    id: { type: Number, default: '' },
    name: { type: String, default: '' },
    project: { type: Object, default: null }
  },
  data() { return { badges: null }; },
  async mounted() {
    await this.loadBadges()
  },
  components: { Img, AnimGroup, AnimBlock, AnimLoader },
  methods: {
    async loadBadges() {
      await fetchAllPages(currentUrl() + `/project/${this.id}/badges`, {}, null, async (response) => {
        this.badges = _.orderBy(_.concat(this.badges || [], response), 'rendered_image_url', 'desc');
      })
    }
  }
}
</script>

<style>
</style>
